/*
    si - Version 0.6 - By Joe Turgeon (jturgeon@isd.net)
    main.h

    si - System Information Viewer
    Copyright (C) 1999  Joe Turgeon (jturgeon@isd.net)

    This program is free software; you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation; either version 2 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#include <ctype.h>
#include <string.h>
#include <time.h>
#include <sys/types.h>
#include <dirent.h>
#include <linux/version.h>


#include "loadinfo.h"
#include "dump.h"


// Global Variables
// File Handles
extern FILE *fstdout;
extern FILE *pipes;
// Kernel Variables
extern int KERNEL_VERSION;
extern const int TWOPOINTTHREE;
extern const int TWOPOINTTWO;
extern const int TWOPOINTONE;
extern const int TWOPOINTZERO;
// Command-Line Argument Variables
extern int OPT_SHOW_SYSTEM;
extern int OPT_SHOW_HARDWARE;
extern int OPT_SHOW_MEMORY;
extern int OPT_SHOW_KERNEL;
extern int OPT_SHOW_FILESYS;
extern int OPT_SHOW_NETWORK;
extern int OPT_SHOW_PROCESS;
extern int OPT_OUTPUT_PAGER;
extern int OPT_OUTPUT_FILE;
extern char OUTPUT_FILE [INPUT_STRING];


// Function Definitions
//	in main.c
extern int main (int argc, char **argv, char **arg);
extern void exit_program (int retval);
extern int kernelversion (int force);
extern int command_line (int argc, char **argv, char **arg);
// 	in loadinfo.c
extern int loadinfo ();
extern void handleproc (int procnum, char *filename);
extern void handlemodules ();
extern void handletime ();
extern void handlecpuv20 ();
extern void handlecpuv22 ();
extern void handledevices ();
extern void handleinterruptsv20 ();
extern void handleinterruptsv22 ();
extern void handlestatv20 ();
extern void handlestatv22 ();
extern void handlememinfo ();
extern void handlemounts ();
extern void handleswaps ();
extern void handleprocesses ();
extern void handlescsi ();
extern void handletty ();
extern void handlesound ();
extern void handlemtrr();
extern void handleide();
extern void handleparport();
extern void handlemisc();
extern int readprocline (char *shortname, struct STRING_ARRAY dataarray[READPROCLINE_COUNT]);
extern int readproc (char *shortname, char *string);
// 	in dump.c
extern void display_dump ();
// 	in tools.c
extern int fgetstr (FILE *point, char *string, int len);
extern int killcrlf (char *string, int len);
extern int instr (char *string, char character);
extern int rstring (char *string, int start, char *retstring);
extern int fillstring (char *string, char chr, int length);
extern int nostr (char *string, char character);
extern int rnostr (char *string, char character);
extern void ltrim (char *string);
extern void rtrim (char *string);
extern void trim (char *string);


