dnl aclocal.m4 generated automatically by aclocal 1.4

dnl Copyright (C) 1994, 1995-8, 1999 Free Software Foundation, Inc.
dnl This file is free software; the Free Software Foundation
dnl gives unlimited permission to copy and/or distribute it,
dnl with or without modifications, as long as this notice is preserved.

dnl This program is distributed in the hope that it will be useful,
dnl but WITHOUT ANY WARRANTY, to the extent permitted by law; without
dnl even the implied warranty of MERCHANTABILITY or FITNESS FOR A
dnl PARTICULAR PURPOSE.

# Do all the work for Automake.  This macro actually does too much --
# some checks are only needed if your package does certain things.
# But this isn't really a big deal.

# serial 1

dnl Usage:
dnl AM_INIT_AUTOMAKE(package,version, [no-define])

AC_DEFUN(AM_INIT_AUTOMAKE,
[AC_REQUIRE([AC_PROG_INSTALL])
PACKAGE=[$1]
AC_SUBST(PACKAGE)
VERSION=[$2]
AC_SUBST(VERSION)
dnl test to see if srcdir already configured
if test "`cd $srcdir && pwd`" != "`pwd`" && test -f $srcdir/config.status; then
  AC_MSG_ERROR([source directory already configured; run "make distclean" there first])
fi
ifelse([$3],,
AC_DEFINE_UNQUOTED(PACKAGE, "$PACKAGE", [Name of package])
AC_DEFINE_UNQUOTED(VERSION, "$VERSION", [Version number of package]))
AC_REQUIRE([AM_SANITY_CHECK])
AC_REQUIRE([AC_ARG_PROGRAM])
dnl FIXME This is truly gross.
missing_dir=`cd $ac_aux_dir && pwd`
AM_MISSING_PROG(ACLOCAL, aclocal, $missing_dir)
AM_MISSING_PROG(AUTOCONF, autoconf, $missing_dir)
AM_MISSING_PROG(AUTOMAKE, automake, $missing_dir)
AM_MISSING_PROG(AUTOHEADER, autoheader, $missing_dir)
AM_MISSING_PROG(MAKEINFO, makeinfo, $missing_dir)
AC_REQUIRE([AC_PROG_MAKE_SET])])

#
# Check to make sure that the build environment is sane.
#

AC_DEFUN(AM_SANITY_CHECK,
[AC_MSG_CHECKING([whether build environment is sane])
# Just in case
sleep 1
echo timestamp > conftestfile
# Do `set' in a subshell so we don't clobber the current shell's
# arguments.  Must try -L first in case configure is actually a
# symlink; some systems play weird games with the mod time of symlinks
# (eg FreeBSD returns the mod time of the symlink's containing
# directory).
if (
   set X `ls -Lt $srcdir/configure conftestfile 2> /dev/null`
   if test "[$]*" = "X"; then
      # -L didn't work.
      set X `ls -t $srcdir/configure conftestfile`
   fi
   if test "[$]*" != "X $srcdir/configure conftestfile" \
      && test "[$]*" != "X conftestfile $srcdir/configure"; then

      # If neither matched, then we have a broken ls.  This can happen
      # if, for instance, CONFIG_SHELL is bash and it inherits a
      # broken ls alias from the environment.  This has actually
      # happened.  Such a system could not be considered "sane".
      AC_MSG_ERROR([ls -t appears to fail.  Make sure there is not a broken
alias in your environment])
   fi

   test "[$]2" = conftestfile
   )
then
   # Ok.
   :
else
   AC_MSG_ERROR([newly created file is older than distributed files!
Check your system clock])
fi
rm -f conftest*
AC_MSG_RESULT(yes)])

dnl AM_MISSING_PROG(NAME, PROGRAM, DIRECTORY)
dnl The program must properly implement --version.
AC_DEFUN(AM_MISSING_PROG,
[AC_MSG_CHECKING(for working $2)
# Run test in a subshell; some versions of sh will print an error if
# an executable is not found, even if stderr is redirected.
# Redirect stdin to placate older versions of autoconf.  Sigh.
if ($2 --version) < /dev/null > /dev/null 2>&1; then
   $1=$2
   AC_MSG_RESULT(found)
else
   $1="$3/missing $2"
   AC_MSG_RESULT(missing)
fi
AC_SUBST($1)])

# Configure paths for VDK
# Salmaso Raffaele 1999-01-22
# stolen from Frank Belew
# stolen from Manish Singh
# Shamelessly stolen from Owen Taylor

dnl AM_PATH_VDK([MINIMUM-VERSION, [ACTION-IF-FOUND [, ACTION-IF-NOT-FOUND]]])
dnl Test for VDK, and define VDK_CFLAGS and VDK_LIBS
dnl
AC_DEFUN(AM_PATH_VDK,
[dnl 
dnl Get the cflags and libraries from the vdk-config script
dnl
AC_ARG_WITH(vdk-prefix,[  --with-vdk-prefix=PFX   Prefix where VDK is installed (optional)],
            vdk_prefix="$withval", vdk_prefix="")
AC_ARG_WITH(vdk-exec-prefix,[  --with-vdk-exec-prefix=PFX Exec prefix where VDK is installed (optional)],
            vdk_exec_prefix="$withval", vdk_exec_prefix="")
AC_ARG_ENABLE(vdktest, [  --disable-vdktest       Do not try to compile and run a test VDK program],
		    , enable_vdktest=yes)

  if test x$vdk_exec_prefix != x ; then
     vdk_args="$vdk_args --exec-prefix=$vdk_exec_prefix"
     if test x${VDK_CONFIG+set} != xset ; then
        VDK_CONFIG=$vdk_exec_prefix/bin/vdk-config
     fi
  fi
  if test x$vdk_prefix != x ; then
     vdk_args="$vdk_args --prefix=$vdk_prefix"
     if test x${VDK_CONFIG+set} != xset ; then
        VDK_CONFIG=$vdk_prefix/bin/vdk-config
     fi
  fi

  AC_PATH_PROG(VDK_CONFIG, vdk-config, no)
  min_vdk_version=ifelse([$1], ,0.6.6,$1)
  AC_MSG_CHECKING(for VDK - version >= $min_vdk_version)
  no_vdk=""
  if test "$VDK_CONFIG" = "no" ; then
    no_vdk=yes
  else
    AC_LANG_SAVE
    AC_LANG_CPLUSPLUS
  
    VDK_CFLAGS=`$VDK_CONFIG $vdkconf_args --cflags`
    VDK_LIBS=`$VDK_CONFIG $vdkconf_args --libs`

    vdk_major_version=`$VDK_CONFIG $vdk_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\1/'`
    vdk_minor_version=`$VDK_CONFIG $vdk_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\2/'`
    vdk_micro_version=`$VDK_CONFIG $vdk_args --version | \
           sed 's/\([[0-9]]*\).\([[0-9]]*\).\([[0-9]]*\)/\3/'`
    if test "x$enable_vdktest" = "xyes" ; then
      ac_save_CXXFLAGS="$CXXFLAGS"
      ac_save_LIBS="$LIBS"
      CXXFLAGS="$CXXFLAGS $VDK_CFLAGS"
      LIBS="$LIBS $VDK_LIBS"
dnl
dnl Now check if the installed VDK is sufficiently new. (Also sanity
dnl checks the results of vdk-config to some extent
dnl
      rm -f conf.vdktest
      AC_TRY_RUN([
#include <stdio.h>
#include <stdlib.h>
#include <vdk/vdkfeatures.h>

int main ()
{
  system ("touch conf.vdktest");

    if (($vdk_major_version > VDK_VERSION_MAJOR) ||
        (($vdk_major_version == VDK_VERSION_MAJOR) && ($vdk_minor_version > VDK_VERSION_MINOR)) ||
	(($vdk_major_version == VDK_VERSION_MAJOR) && ($vdk_minor_version == VDK_VERSION_MINOR) &&
	($vdk_micro_version >= VDK_VERSION_MICRO)))
    {
      return 0;
    }
  else
    {
      printf("\n*** 'vdk-config --version' returned %d.%d, but the minimum version\n", $vdk_major_version, $vdk_minor_version);
      printf("*** of VDK required is %d.%d. If vdk-config is correct, then it is\n", VDK_VERSION_MAJOR, VDK_VERSION_MINOR);
      printf("*** best to upgrade to the required version.\n");
      printf("*** If vdk-config was wrong, set the environment variable VDK_CONFIG\n");
      printf("*** to point to the correct copy of vdk-config, and remove the file\n");
      printf("*** config.cache before re-running configure\n");
      return 1;
    }
}

],, no_vdk=yes,[echo $ac_n "cross compiling; assumed OK... $ac_c"])
       CXXFLAGS="$ac_save_CXXFLAGS"
       LIBS="$ac_save_LIBS"
     fi
  fi
  if test "x$no_vdk" = x ; then
     AC_MSG_RESULT(yes)
     ifelse([$2], , :, [$2])     
  else
     AC_MSG_RESULT(no)
     if test "$VDK_CONFIG" = "no" ; then
       echo "*** The vdk-config script installed by VDK could not be found"
       echo "*** If VDK was installed in PREFIX, make sure PREFIX/bin is in"
       echo "*** your path, or set the VDK_CONFIG environment variable to the"
       echo "*** full path to vdk-config."
     else
       if test -f conf.vdktest ; then
        :
       else
          echo "*** Could not run VDK test program, checking why..."
          CXXFLAGS="$CXXFLAGS $VDK_CFLAGS"
          LIBS="$LIBS $VDK_LIBS"
          AC_TRY_LINK([
#include <stdio.h>
#include <vdk/vdk.h>
],      [ return 0; ],
        [ echo "*** The test program compiled, but did not run. This usually means"
          echo "*** that the run-time linker is not finding VDK or finding the wrong"
          echo "*** version of VDK. If it is not finding VDK, you'll need to set your"
          echo "*** LD_LIBRARY_PATH environment variable, or edit /etc/ld.so.conf to point"
          echo "*** to the installed location  Also, make sure you have run ldconfig if that"
          echo "*** is required on your system"
	  echo "***"
          echo "*** If you have an old version installed, it is best to remove it, although"
          echo "*** you may also be able to get things to work by modifying LD_LIBRARY_PATH"],
        [ echo "*** The test program failed to compile or link. See the file config.log for the"
          echo "*** exact error that occured. This usually means VDK was incorrectly installed"
          echo "*** or that you have moved VDK since it was installed. In the latter case, you"
          echo "*** may want to edit the vdk-config script: $VDK_CONFIG" ])
          CXXFLAGS="$ac_save_CXXFLAGS"
          LIBS="$ac_save_LIBS"
       fi
     fi
     VDK_CFLAGS=""
     VDK_LIBS=""
     ifelse([$3], , :, [$3])
  fi
  VDK_VERSION_MAJOR=0
  VDK_VERSION_MINOR=6
  VDK_VERSION_MICRO=6
  AC_SUBST(VDK_VERSION_MAJOR)
  AC_SUBST(VDK_VERSION_MINOR)
  AC_SUBST(VDK_VERSION_MICRO)
  AC_SUBST(VDK_CFLAGS)
  AC_SUBST(VDK_LIBS)
  rm -f conf.vdktest
])

# Like AC_CONFIG_HEADER, but automatically create stamp file.

AC_DEFUN(AM_CONFIG_HEADER,
[AC_PREREQ([2.12])
AC_CONFIG_HEADER([$1])
dnl When config.status generates a header, we must update the stamp-h file.
dnl This file resides in the same directory as the config header
dnl that is generated.  We must strip everything past the first ":",
dnl and everything past the last "/".
AC_OUTPUT_COMMANDS(changequote(<<,>>)dnl
ifelse(patsubst(<<$1>>, <<[^ ]>>, <<>>), <<>>,
<<test -z "<<$>>CONFIG_HEADERS" || echo timestamp > patsubst(<<$1>>, <<^\([^:]*/\)?.*>>, <<\1>>)stamp-h<<>>dnl>>,
<<am_indx=1
for am_file in <<$1>>; do
  case " <<$>>CONFIG_HEADERS " in
  *" <<$>>am_file "*<<)>>
    echo timestamp > `echo <<$>>am_file | sed -e 's%:.*%%' -e 's%[^/]*$%%'`stamp-h$am_indx
    ;;
  esac
  am_indx=`expr "<<$>>am_indx" + 1`
done<<>>dnl>>)
changequote([,]))])

