/*
 * ===========================
 * VDK Builder
 * Version 0.1.1
 * Revision 0.0
 * March 1999
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library 
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#include <vdkb_form.h>
#include <vdkb_prjman.h>
#include <vdkb_locale.h>
#include <vdkb_dlgs.h>
#include <vdkb_evbox.h>
#include <vdkb_frame.h>
#include <vdkb_scrolled.h>
#include <vdkb_menubar.h>
#include <vdkb.h>
#include <vdkb_utils.h>
#include <vdkb_menuitem.h>
#include <vdkb_paned.h>
#include <vdkb_notebook.h>
#include <vdkb_toolbar.h>
#include <vdkb_table.h>
#include <vdkb_handlebox.h>
#include <vdkb_rbgroup.h>
#include <vdkb_packer.h>
#include <vdkb_fixed.h>
#include <vdkb_objinspect.h>
#include <gdk/gdkkeysyms.h>
#define VERBOSE 0

extern OpState  OperationalState;
static char buff[256];
/*
yes agreed, this isn't a good c++ style,
but believe me if you would have to fight
with my new  gcc version egcs-2.91.66 19990314 
(egcs-1.1.2 release) you have to invent some 
old dirty tricks
*/ 

VDKBConnection::VDKBConnection(char* sender, char* signal, 
		 char* slot, bool declare)
{
VDKBConnection::sender = sender;
VDKBConnection::signal = signal;
VDKBConnection::slot = slot;
VDKBConnection::declare = declare;
}
/*
 */
bool 
VDKBConnection::operator==(VDKBConnection& c)
{ 
return sender == c.sender && signal == c.signal && slot == c.slot; 
}
/*
 */
bool 
VDKBConnection::operator<(VDKBConnection& c)
{ 
return sender < c.sender; 
}

////////////////////////////////////////
//
///////////////////////////////////////
// in vdkb_design.cc
extern FormEventHandlers evTableItems  [];

/* 
 properties names
 */
char* vdkform_props[] =
{ 
"Title",0
};
DEFINE_EVENT_LIST(VDKBGuiForm,VDKForm);

DEFINE_SIGNAL_LIST(VDKBGuiForm,VDKForm);

/*
 */
VDKObject*
VDKBGuiForm::ChildWithName(char* name)
{
VDKString thisname = name;
VDKObject *found = (VDKObject*) NULL;
EventBoxListIterator li(innerbox->boxlist);
for(;li;li++)
  {
    VDKObject* object = li.current();
    VDKBObject* vdkobj = dynamic_cast<VDKBObject*>(object);
    if(vdkobj && (vdkobj->Name() == thisname) )
      {
	found =  object;//vdkobj;
	if(found)
	  break;
      }
    else if(vdkobj && dynamic_cast<VDKBEventContainer*>(vdkobj))
      {
	VDKBEventContainer* box = (VDKBEventContainer*) vdkobj;
	found =  RecursiveChildWithName(box->boxlist, name);
	if(found)
	  break;
      }
  }
return found;
}
/* 
 */
VDKObject*
VDKBGuiForm::RecursiveChildWithName(EventBoxList& list,char* name)
{
  if(list.size() == 0)
    return NULL;
  VDKString thisname = name;
  EventBoxListIterator li(list);
  VDKObject *found = (VDKObject*) NULL;
  for(;li;li++)
    {
      VDKObject* object = li.current();
      VDKBObject* vdkobj = dynamic_cast<VDKBObject*>(object);
       if(vdkobj && (vdkobj->Name() == thisname) )
	 {
	   found =  object;//vdkobj;
	   if(found)
	     break;
	 }
       else if(vdkobj && dynamic_cast<VDKBEventContainer*>(vdkobj))
	 {
	   VDKBEventContainer* box = (VDKBEventContainer*) vdkobj;
	   found =  RecursiveChildWithName(box->boxlist,name);
	   if(found)
	     break;
	 }
       else  if(vdkobj && dynamic_cast<VDKBMenuItem*>(vdkobj))
	 {
	   VDKBMenuItem* item = (VDKBMenuItem*) vdkobj;
	   found =  RecursiveChildWithName(item->boxlist,name);
	   if(found)
	     break;
	 }

    }
return found;
}
/*
 */
void 
VDKBGuiForm::AddWidget(VDKObject* obj, int justify,
		       int expand, int fill , int padding, 
		       bool forceArgs)
{
if(innerbox)
  innerbox->Add(obj,justify, expand, fill, padding);
Changed = true;
}
/*
 */
bool
VDKBGuiForm::AddVBox(VDKObject*)
{
  for(sprintf(buff,"vbox%d",VDKBEventBox::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBEventBox::Counter++)
    sprintf(buff,"vbox%d",VDKBEventBox::Counter);
  VDKBEventBox *box = new VDKBEventBox(buff,innerbox);
  innerbox->Add(box);
  Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddHBox(VDKObject*)
{
  for(sprintf(buff,"hbox%d",VDKBEventBox::Counter);
      ChildWithName(buff)!= (VDKObject*) NULL;
      VDKBEventBox::Counter++)
    sprintf(buff,"hbox%d",VDKBEventBox::Counter);
  VDKBEventBox *box = new VDKBEventBox(buff,innerbox,h_box);
  innerbox->Add(box);
  //  Changed = true;
  return true;
}

/*
 */
bool
VDKBGuiForm::AddVFrame(VDKObject*)
{
  for(sprintf(buff,"frame%d",VDKBFrame::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBFrame::Counter++)
    sprintf(buff,"frame%d",VDKBFrame::Counter);
  VDKBFrame *frame = new VDKBFrame(buff,innerbox);
  for(sprintf(buff,"vbox%d",VDKBEventBox::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBEventBox::Counter++)
    sprintf(buff,"vbox%d",VDKBEventBox::Counter);
  VDKBEventBox *box1 = new VDKBEventBox(buff,frame);
  box1->SetPropValue(JUSTIFY_INTERNAL,"l_justify");
  frame->AddWidget(box1,l_justify,true,true,true,true);
  innerbox->Add(frame);
  //  Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddToolbar(VDKObject*)
{
  for(sprintf(buff,"toolbar%d",VDKBToolbar::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBToolbar::Counter++)
    sprintf(buff,"toolbar%d",VDKBToolbar::Counter);
  VDKBToolbar *tbar = new VDKBToolbar(buff,innerbox);
  innerbox->Add(tbar,l_justify,false,false,false);
  //  Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddHandleBox(VDKObject*)
{
  for(sprintf(buff,"handlebox%d",VDKBHandleBox::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBHandleBox::Counter++)
    sprintf(buff,"handlebox%d",VDKBHandleBox::Counter);
  VDKBHandleBox *hb = new VDKBHandleBox(buff,innerbox);
  innerbox->Add(hb,l_justify,false,false,false);
  //  Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddPacker(VDKObject*)
{
  for(sprintf(buff,"packer%d",VDKBPacker::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBPacker::Counter++)
    sprintf(buff,"packer%d",VDKBPacker::Counter);
  VDKBPacker *hb = new VDKBPacker(buff,innerbox);
  innerbox->Add(hb,l_justify,true,true,false);
  //  Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddFixed(VDKObject*)
{
  for(sprintf(buff,"fixed%d",VDKBFixed::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBFixed::Counter++)
    sprintf(buff,"fixed%d",VDKBFixed::Counter);
  VDKBFixed *hb = new VDKBFixed(buff,innerbox);
  innerbox->Add(hb,l_justify,true,true,false);
  //Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddScrolled(VDKObject*)
{
  for(sprintf(buff,"scrolled%d",VDKBScrolled::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBScrolled::Counter++)
    sprintf(buff,"scrolled%d",VDKBScrolled::Counter);
  VDKBScrolled *scrolled = new VDKBScrolled(buff,innerbox);
  innerbox->Add(scrolled);
  //  Changed = true;
  return true;
}
/*
OBSOLETE
usr is forced to add a table to
another container
 */
bool
VDKBGuiForm::AddTable(VDKObject*)
{
  int rows = 3, cols = 3;
  for(sprintf(buff,"table%d",VDKBTable::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBTable::Counter++)
    sprintf(buff,"table%d",VDKBTable::Counter);
  VDKBTable *table = new VDKBTable(buff,innerbox,rows,cols,true);
  innerbox->Add(table);
  //  Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddMenubar(VDKObject*)
{
  for(sprintf(buff,"Menubar%d",VDKBMenubar::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBMenubar::Counter++)
    sprintf(buff,"Menubar%d",VDKBMenubar::Counter);
  VDKBMenubar *menubar = new VDKBMenubar(buff,innerbox);
  innerbox->Add(menubar,l_justify,false,false,false);
  menubar->Parent(innerbox);
  //  Changed = true;
  return true;
}
/*
 */
bool
VDKBGuiForm::AddNotebook(VDKObject*)
{
  char local[64];
  for(sprintf(buff,"Nbook%d",VDKBGuiNotebook::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBGuiNotebook::Counter++)
    sprintf(buff,"Nbook%d",VDKBGuiNotebook::Counter);
  VDKBGuiNotebook *notebook = new VDKBGuiNotebook(buff,innerbox);
  innerbox->Add(notebook);
  sprintf(local,"%s_Page%d",buff,notebook->nbook->Pages.size());
  VDKBEventBox *box = new VDKBEventBox(local,notebook);
  notebook->AddWidget(box);
  //  Changed = true;
  return true;
} 
/*
 */
bool
VDKBGuiForm::AddHPaned(VDKObject*)
{
  for(sprintf(buff,"HPaned%d",VDKBPaned::Counter);
      ChildWithName(buff)!= (VDKObject*) NULL;
      VDKBPaned::Counter++)
    sprintf(buff,"HPaned%d",VDKBPaned::Counter);
  VDKBPaned *paned = new VDKBPaned(buff,innerbox,h_box);
   // add two boxes to panes
  for(sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBEventBox::Counter++)
    sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
  VDKBEventBox *box1 = new VDKBEventBox(buff,paned);
  box1->SetPropValue(JUSTIFY_INTERNAL,"c_justify");
  // to pane 1
  paned->AddWidget(box1,c_justify);
  //
  for(sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBEventBox::Counter++)
    sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
  VDKBEventBox *box2 = new VDKBEventBox(buff,paned);
  box2->SetPropValue(JUSTIFY_INTERNAL,"r_justify");
  // to pane 2
  paned->AddWidget(box2,r_justify);
  //  Changed = true;
  innerbox->Add(paned);
  return true;
}
/*
 */
bool
VDKBGuiForm::AddVPaned(VDKObject*)
{
  for(sprintf(buff,"VPaned%d",VDKBPaned::Counter);
      ChildWithName(buff)!= (VDKObject*) NULL;
      VDKBPaned::Counter++)
    sprintf(buff,"VPaned%d",VDKBPaned::Counter);
  VDKBPaned *paned = new VDKBPaned(buff,innerbox,v_box);
  // add two boxes to panes
  for(sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBEventBox::Counter++)
    sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
  VDKBEventBox *box1 = new VDKBEventBox(buff,paned);
  box1->SetPropValue(JUSTIFY_INTERNAL,"c_justify");
  // to pane 1
  paned->AddWidget(box1,c_justify);
  //
  for(sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBEventBox::Counter++)
    sprintf(buff,"Vbox%d",VDKBEventBox::Counter);
  VDKBEventBox *box2 = new VDKBEventBox(buff,paned);
  box2->SetPropValue(JUSTIFY_INTERNAL,"r_justify");
  // to pane 2
  paned->AddWidget(box2,r_justify);
  //  Changed = true;
  innerbox->Add(paned);
  return true;
}
/*
 */
bool
VDKBGuiForm::AddVRadioBg(VDKObject*)
{
  for(sprintf(buff,"VRadioButtonGroup%d",VDKBRadioButtonGroup::Counter);
      ChildWithName(buff) != (VDKObject*) NULL;
      VDKBRadioButtonGroup::Counter++)
    sprintf(buff,"VRadioButtonGroup%d",VDKBRadioButtonGroup::Counter);
  VDKBRadioButtonGroup *box = new VDKBRadioButtonGroup(buff,innerbox);
  innerbox->Add(box);
  //  Changed = true;
  return true;
}
/*
this methods is the main entry point of 
all mouse clicking since all widgets
propagate click event until here.
LOGIC:
- event is processed to see wich button was presses:
1. BUTTON 1 (left click)
- operational state is checked to see if the user
selected a widget from tool palette
*/
extern int
MakeWidget(VDKBGuiForm* owner, int action_target, GdkEvent* ev = NULL);

bool 
VDKBGuiForm::OnButtonPress(VDKObject* sender, GdkEvent* ev)
{
  int result = 99;
  GdkEventButton *event = (GdkEventButton*) ev;
  switch(event->button)
  {
  case 1: // handle left-mouse button click
    // operational state shows that user has selected a widget
    // from tool palette
    if(OperationalState.state == op_stand_by &&
       OperationalState.action == act_add_widget &&
       OperationalState.target == NULL)
	{
	  // filters widget ids to refuse those that cannot
	  // be added to another object
	  switch(OperationalState.action_target)
	    {
	    case CONTAINERS_TOOL_MENUBAR:
	      result = 3;
	      break;
	    default:
	      // adding widgets to containers takes precedence
	      if(sender)
		{
		  VDKBObject* vdkbobj = dynamic_cast<VDKBObject*>(sender);
		  if(vdkbobj && dynamic_cast<VDKBFixed*>(vdkbobj))
		    {
		      result = MakeWidget(this,
					  OperationalState.
					  action_target,ev);
		    }
		  else
		    // do not pass coordinates
		    result = MakeWidget(this,OperationalState.action_target);
		}
	      else
		// calling with NULL add to inner box
		result = 3;
	      break;
	    }
	  // adding unsuccessfull due to non active widget
	  // will be added to an empty form
	  // Only containers are allowed to be added to an empty
	  // form.
	  if(result == 3)
	    {
	      switch(OperationalState.action_target)
		{
		case CONTAINERS_TOOL_VBOX:  AddVBox(NULL);  result = 0;  
		  break;
		case CONTAINERS_TOOL_HBOX:  AddHBox(NULL);  result = 0;  
		  break;
		case CONTAINERS_TOOL_FRAME: AddVFrame(NULL); result = 0; 
		  break;
		case CONTAINERS_TOOL_SCROLLED: AddScrolled(NULL); result = 0; 
		  break;
		case CONTAINERS_TOOL_MENUBAR: AddMenubar(NULL); result = 0; 
		  break;
		case CONTAINERS_TOOL_VPANED: AddVPaned(NULL); result = 0; 
		  break;
		case CONTAINERS_TOOL_HPANED: AddHPaned(NULL); result = 0; 
		  break;
		case CONTAINERS_TOOL_NBOOK: AddNotebook(NULL); result = 0; 
		  break;
		case CONTAINERS_TOOL_TOOLBAR: AddToolbar(NULL);result = 0; 
		  break;
		case CONTAINERS_TOOL_HANDLE: AddHandleBox(NULL);result = 0; 
		  break;  
		case CONTAINERS_TOOL_VRADIOBG: AddVRadioBg(NULL);result = 0;
		  break;
		case CONTAINERS_TOOL_PACKER: AddPacker(NULL);result = 0;
		  break;
		case CONTAINERS_TOOL_FIXED: AddFixed(NULL);result = 0;
		  break;
		default: result = 2;
		}
	    }
	  // parse result
	  switch(result)
	    {
	    case 1: // unsupported widget
	      sprintf(buff,
		      "Sorry, unsupported widget");
	      break;
	    case 2: // unimplemented operation
	      sprintf(buff,
		      "Sorry, unauthorized or unimplemented operation");
	      break;
	    case 4: // unuseful add a container to an empty container
	      sprintf(buff,
		      "Sorry, nested layouts disabled");
	      break;
	    default:
	      sprintf(buff,
		      "Sorry, unknown editing error");
	      break;
	    }
	  if(result)
	    Application()->MessageBox(APPNAME,buff,
				      MB_OK| MB_ICONINFORMATION,
				      user_messages[user_ok],
				      NULL, 2000);
	  // reset all selection
	  // at operation end
	  // in the future this should evolve into
	  // a multi-widgets selection
	  ((VDKBMainForm*)Application()->MainForm)->Reset(NULL);
	  // load widget tree
	  VDKBProjectManager* prjman = 
	    dynamic_cast<VDKBProjectManager*>(Owner());
	  if(prjman && prjman->objInspector)
	    prjman->objInspector->LoadTree(this);
	}
    // 
    // normally processes a left click
    else if(sender && sender != innerbox)
      // try to activate an object inspector
      // refusing those coming from inner box
      {
	VDKBObject* vdkbobj = dynamic_cast<VDKBObject*>(sender);
	VDKBProjectManager* prjman = 
	  dynamic_cast<VDKBProjectManager*>(Owner());
	if(prjman && prjman->objInspector && vdkbobj)
	  prjman->objInspector->SelectWidgetByTree(vdkbobj);
      }
    break;

  case 3:
    // handle right mouse click
    if(sender != innerbox)
      // try to activate an object inspector
      // refusing those coming from inner box
      {
	VDKBObject* vdkbobj = dynamic_cast<VDKBObject*>(sender);
	VDKBProjectManager* prjman = 
	  dynamic_cast<VDKBProjectManager*>(Owner());
	if(vdkbobj && prjman && prjman->objInspector )
	  prjman->objInspector->SelectWidgetByTree(vdkbobj);
      }
    
    break;
    // no others possibilities
  default:
    break;
  }
  return true;
}



/*
 */
bool
VDKBGuiForm::SetBoxSize(VDKObject* sender)
{
if(!dialog && Active)
  {
    sprintf(buff,"Setting %s size", (char*) Active->Name());
    dialog = new VDKBPropSizeDialog(this,Active,buff);
    dialog->Setup();
    dialog->ShowModal();
    //    Changed = true;
  }
return true;  
}
//////////////////////////////////////////////////
//
//
//////////////////////////////////////////////////
VDKBGuiForm::VDKBGuiForm(VDKForm* owner, char* name,
			 char* filename,
			 char* title, int mode, 
			 GtkWindowType display):
  VDKForm(owner,title,display),VDKBObject(name),
  name(name),filename(filename)
{
  ForceToClose = false;
  Active = NULL;
  dialog = NULL;
  innerbox = NULL;
  Changed = false;
  // assign this to VDKBObject <object> member.
  object = this;
  int t;
  for(t=0; evTableItems[t].items[0]; t++)
    proplist.add(VDKBProperty(evTableItems[t].items[0]));
  for(t=0; vdkform_props[t]; t++)
    proplist.add(VDKBProperty(vdkform_props[t]));
}


/*
 */
void
VDKBGuiForm::Setup(VDKBParser& parser, char* formname)
{
  // avoid infinite recursion
  // make an empty innerbox <arg> true
  Add(innerbox = new VDKBEventBox(buff,this,true));
  // setup default props
  SetupFormProperties(parser,name);
  // makes gui objects
  MakeGuiObjects(parser);
  // read signal file
  // and upload form SignalList
  ReadSignals(parser);
  // connect events
  EventConnect("focus_in_event",&VDKBGuiForm::OnFocusIn);
  EventConnect("focus_out_event",&VDKBGuiForm::OnFocusOut);
  EventConnect(innerbox,"button_press_event",&VDKBGuiForm::OnButtonPress);
  EventConnect("expose_event",&VDKBGuiForm::OnExpose);
  // connect form with key event
  // only for fixed moving/sizing
  EventConnect("key_press_event",&VDKBGuiForm::OnKey);
  EventConnect("key_release_event",&VDKBGuiForm::OnKeyRelease);
  // set initial position
  gtk_window_position(GTK_WINDOW(Window()),GTK_WIN_POS_NONE);


} 
/*
 */
// in vdkb_parser.cc
extern bool
CreateWidget(VDKBGuiForm* owner, char* classname, 
	     char* buffer,VDKBParser& parser );

void
VDKBGuiForm::MakeGuiObjects(VDKBParser& parser)
{
  char arg[64];
  char* object;
  char obj_name[128];
  char obj_type[64];
  char* p = parser.Buffer();

  while( (p = strstr(p,"[object]")) )
    {
      sprintf(arg,"[object]{");
      object = ExtractSection(p,arg,"}");
      if(object)
	{
	  if(parser.GetObjectClass(object,obj_type) &&
	     parser.GetObjectName(object,obj_name) )
	    // create gui widget
	    // using global scope resolution operator
	    // to avoid ambiguity with VDKObject::CreateWidget()
	    ::CreateWidget(this,obj_type,p,parser);
	  p+=strlen(object);
	  delete object;
	}
  }
}
/*
 */
void
VDKBGuiForm::SetupFormProperties(VDKBParser& parser, 
				 char* formname)
{
  char arg[128];
  int t;
  char* object = parser.GetObject(formname);
  if(!object)
    return;
  DesignedSize = parser.Size(object);
  if(parser.GetParam(arg,object,"Title:"))
    {
      Title = arg;
      SetPropValue("Title",arg);
    }
  // others properties
  VDKBObject::CreateWidget(this, object, parser);

  // event handlers
  for(t=0; evTableItems[t].items[0];t++)
    {
      sprintf(buff,"%s:",evTableItems[t].items[0]);
      if(parser.GetParam(arg,object,buff))
	    SetPropValue(evTableItems[t].items[0],arg);
    }
  delete object;
}
/*
 */
void 
VDKBGuiForm::OnResize(VDKForm*, VDKPoint& newsize)
{
#if VERBOSE
  printf("\nnew size:p(%d,%d)",newsize.x,newsize.y);
  fflush(stdout);
#endif

  if( (newsize.X() > 20) && 
      (newsize.Y() > 20) && 
      (DesignedSize != newsize)
      )
    {
      DesignedSize = newsize;
      Changed = true;
    }
}
/*
 */
bool 
VDKBGuiForm::OnFocusIn(VDKObject*, GdkEvent*)
{
  VDKBProjectManager* prjman = (VDKBProjectManager*) Owner();
  // in vdkb_design.cc
  prjman->ActivateChild(this,true);
  return true;

}
/*
 */
bool 
VDKBGuiForm::OnExpose(VDKObject*, GdkEvent*)
{
if(Active)
  Active->Mark();
return true;
}
/*
 */
bool 
VDKBGuiForm::OnFocusOut(VDKObject*, GdkEvent*)
{
  VDKBProjectManager* prjman = (VDKBProjectManager*) Owner();
  // in vdkb_design.cc
  prjman->ActivateChild(this,false);
  return true;
}
/*
 */

bool 
VDKBGuiForm::CanClose() 
{
if(! ForceToClose)
  {
    // simulates closing
    Visible = false; 
    Owner()->OnChildClosing(this);
    return false; 
  }
else
  return true;
}
/*
 */
void 
VDKBGuiForm::OnChildClosing(VDKForm* child)
{
if(child == dialog)
  dialog = NULL;
}

void 
VDKBGuiForm::WriteFormFile()
{
  FILE* fp = fopen(filename,"w+");
  char* fname = (char*) Name();
  if(!fp)
    return; // FIX ME user warning
  fprintf(fp,"[%s]\n{\n\tclass:form;",fname);
  fprintf(fp,"\n\t%s.this:%s;",fname,fname);
  fprintf(fp,"\n\t%s.%s%s;",
	  fname,
	  PROP_NORMALBACKGROUND,
	  (char*) GetProp(NORMALBACKGROUND));
  fprintf(fp,"\n\t%s.%s%s;",
	  fname,
	  PROP_FOREGROUND,
	  (char*) GetProp(FOREGROUND));
  fprintf(fp,"\n\t%s.%s%s;",
	  fname,
	  PROP_FONT,
	  (char*) GetProp( FONT));
  fprintf(fp,"\n\t%s.%s%s;",
	  fname,
	  PROP_CURSOR,
	  (char*) GetProp(CURSOR));
  sprintf(buff,"%4d,%4d",DesignedSize.X(),DesignedSize.Y());
  fprintf(fp,"\n\t%s.%s%s;",fname,PROP_USIZE,buff);
  fprintf(fp,"\n\t%s.Title:\"%s\";",fname,
	  (char*) GetProp("Title"));
  // event handlers
  int t;
  for(t=0; evTableItems[t].items[0];t++)
    {
      fprintf(fp,"\n\t%s.%s:%s;",
	      fname,
	      evTableItems[t].items[0],
	      (char*) GetProp(evTableItems[t].items[0]));
    }
  fprintf(fp,"\n}");
  // recursively writes boxes
  WriteBoxesOnFrm(fp);
  // writes signals
  WriteSignals(fp);
  fclose(fp);
}
/*
 */
void
VDKBGuiForm::WriteBoxesOnFrm(FILE* fp)
{
EventBoxListIterator li(innerbox->boxlist);
for(;li;li++)
  {
    VDKObject* object = li.current();
    VDKBObject* vdkobj = dynamic_cast<VDKBObject*>(object);
    if(vdkobj && vdkobj->isA() != vdkbcanvas_class)
      {
      // fp and parent (nihil in this case)
      vdkobj->WriteOnFrm(fp,NULL);
      vdkobj->WriteOnFrmEnd(fp);
      }
    if(vdkobj && dynamic_cast<VDKBEventContainer*>(vdkobj))
      {
	VDKBEventContainer* box = (VDKBEventContainer*) vdkobj;
	RecursiveWriteBoxesOnFrm(vdkobj,box->boxlist,fp);
      }
  }
}
/*
Don't be mangled with <boxes> name,
really boxes can contain any widget
 */
void
VDKBGuiForm::RecursiveWriteBoxesOnFrm(VDKBObject* parentobj,
				EventBoxList& list, FILE* fp)
{
  if(list.size() == 0)
    return;
  // iterates on boxes
  EventBoxListIterator li(list);
  for(;li;li++)
    {
      VDKObject* object = li.current();
      VDKBObject* vdkobj = dynamic_cast<VDKBObject*>(object);
      // gui widgets inner canvases must be neglected
       if(vdkobj && vdkobj->isA() != vdkbcanvas_class)
	 {
	   vdkobj->WriteOnFrm(fp,parentobj);
	   vdkobj->WriteOnFrmEnd(fp);
	 }
       // recurs on inner boxes or menu items (if any)
       if(vdkobj && dynamic_cast<VDKBEventContainer*>(vdkobj))
	 {
	   VDKBEventContainer* box = (VDKBEventContainer*) vdkobj;
	   RecursiveWriteBoxesOnFrm(vdkobj,box->boxlist,fp);
	 }
       else  if(vdkobj && dynamic_cast<VDKBMenuItem*>(vdkobj))
	 {
	   VDKBMenuItem* item = (VDKBMenuItem*) vdkobj;
	   if(item)
	     RecursiveWriteBoxesOnFrm(vdkobj,item->boxlist,fp);
	 }
    }
}
/*
 */
void 
VDKBGuiForm::WriteSignals(FILE* fp)
{
  VDKBConnectionListIterator li(SignalList);
  for(;li;li++)
    {
      fprintf(fp,"\n[connect]{");
      fprintf(fp,"\n\tsender:%s;",(char*) li.current().sender);
      fprintf(fp,"\n\tsignal:%s;",(char*) li.current().signal);
      fprintf(fp,"\n\tslot:%s;",(char*) li.current().slot);
      fprintf(fp,"\n\tdeclare:%s;", li.current().declare ? "1" : "0");
      fprintf(fp,"}");
    }
}

/*
This is called by WidgetPopmenu::DelWidget(VDKObject*)
when an object is removed.
 */
void 
VDKBGuiForm::DisconnectWidget(VDKBObject* wid)
{
  g_return_if_fail(wid != NULL);
  VDKString sender = wid->Name();
  VDKBConnectionList list;
  VDKBConnectionListIterator li(SignalList);
  // make a collection of all matching names
  for(;li;li++)
    {
      if(li.current().sender == sender)
	list.add(li.current());
    }
  if(list.size() <= 0)
    return;
  // delete collection in original list
  VDKBConnectionListIterator ld(list);
  for(;ld;ld++)
    {
      int ndx = SignalList.at(ld.current());
      if(ndx>=0)
	SignalList.unlink(ndx);
    }
}
void 
VDKBGuiForm::ChangeConnectionSenderName(VDKString& newname, 
					VDKString& oldname)
{
  VDKBConnectionListIterator li(SignalList);
  for(;li;li++)
    {
      if(li.current().sender == oldname)
	li.current().sender = newname;
    }

}
/////////////////////////////////////////////////////
//           OBJECT INSPECTOR MANAGEMENT
////////////////////////////////////////////////////
/*
 */
VDKObjectContainer* 
VDKBGuiForm::ExtraWidget(VDKBObjectInspector* isp) 
{ 
  inspector = isp;
  VDKFrame* bframe = new VDKFrame(inspector,NULL,v_box,shadow_etched_in);
  // FIX ME: lang support
  VDKTable* table = new VDKTable(inspector,1,2,true);
  VDKLabelButton* button = 
    new VDKLabelButton(inspector,"Set form title");
  table->AddToCell(button,0,0);
  button->Parent(this);
  SignalConnect(button,"clicked",&VDKBGuiForm::OnSetFormTitle);
  title = new VDKEntry(inspector,0,(char*) GetProp("Title"));
  title->SetSize(100,-1);
  table->AddToCell(title,0,1);
  bframe->Add(table,l_justify,false,false,false);
  return bframe; 
}
/*
 */
bool
VDKBGuiForm::OnSetFormTitle(VDKObject*)
{
  if(strlen(title->Text)>0)
    sprintf(buff,"%s",(char*) title->Text);
  else
    sprintf(buff,"%s",NIHIL_PROP);
  SetPropValue("Title",buff);
  Title = VDKString(title->Text);
  inspector->FormNeedToBeChanged();
  return true;
}

/*
here we manage moving - resizing for those widget contained
into a fixed.
Logic:
left,up,right,down key : moving (fine tuning: 1 pixel)
shif + <left,up,right,down> key: moving to snap grid
ctrl + left,up,right,down key: sizing (fine tuning: 1 pixel)
ctrl + shift + <left,up,right,down> key: sizing to snap grid
*/
extern "C" 
{
void
fixed_draw_grid (GtkWidget * widget,
		 int grid_horz_spacing,
		 int grid_vert_spacing,
		 int grid_style);
}

static void 
snap_left(VDKPoint& new_position, 
	  int horz_spacing)
{
  if(!(new_position.x%horz_spacing))
    new_position.x -= horz_spacing;
  else
    {
      //snaps left
      new_position.x += horz_spacing / 2;
      new_position.x -= new_position.x % horz_spacing;
      new_position.x -= horz_spacing;
    }
}

static void 
snap_right(VDKPoint& new_position, 
	   int horz_spacing)
{
  if(!(new_position.x%horz_spacing))
    new_position.x += horz_spacing;
  else
    {
      //snaps right
      new_position.x += horz_spacing / 2;
      new_position.x -= new_position.x % horz_spacing;
    }
}
static void 
snap_top(VDKPoint& new_position, 
	 int vert_spacing)
{
  if(!(new_position.y%vert_spacing))
    new_position.y -= vert_spacing;
  else
    {
      //snaps top
      new_position.y += vert_spacing / 2;
      new_position.y -= new_position.y % vert_spacing;
    }
}

static void 
snap_bottom(VDKPoint& new_position, 
	    int vert_spacing)
{
  if(!(new_position.y%vert_spacing))
    new_position.y += vert_spacing;
  else
    {
      //snaps bottom
      new_position.y += vert_spacing / 2;
      new_position.y -= new_position.y % vert_spacing;
    }
}


bool
VDKBGuiForm::OnKey(VDKObject* sender, GdkEvent* ev) 
{
  g_return_val_if_fail (sender != NULL, FALSE); 
  g_return_val_if_fail (ev != NULL, FALSE); 
  gtk_signal_emit_stop_by_name(GTK_OBJECT(sender->Widget()),
			       "key_press_event");
  GdkEventKey* event = (GdkEventKey*) ev;
  HandleOnKey(sender,event);
  return true;
}

bool
VDKBGuiForm::OnKeyRelease(VDKObject* sender, GdkEvent* ev) 
{
  VDKBEventContainer* container = NULL;
  VDKBFixed* fixed = NULL;
  gtk_signal_emit_stop_by_name(GTK_OBJECT(sender->Widget()),
			       "key_release_event");
  // we check if:
  // - there is an active widget
  // - active widget has a parent container
  // - parent container is a fixed 
  //
#if VERBOSE
  printf("\n VDKBGuiForm::OnKeyRelease - %s",
	 gtk_widget_get_name (sender->Widget())
	 );
  fflush(stdout);
#endif
  if(!Active)
    return true;
  else
    {
      // mark object
      Active->Mark();
      container = 
	dynamic_cast<VDKBEventContainer*>(Active->Object()->Parent());
    }
#if VERBOSE
  printf("\n VDKBGuiForm::OnKeyRelease - %s(2)",
	 gtk_widget_get_name (sender->Widget())
	 );
  fflush(stdout);
#endif
  if(container && (fixed = dynamic_cast<VDKBFixed*>(container)) )
    {
      bool have_grid = false;
      int horz_spacing = 1,vert_spacing = 1;
      VDKString isTrue = CHECK_TRUE;
#if VERBOSE
  printf("\n VDKBGuiForm::OnKeyRelease - fixed: %s(3)",
	 gtk_widget_get_name (sender->Widget())
	 );
  fflush(stdout);
#endif

      if(fixed && fixed->GetProp("have_grid") == isTrue)
	{
	  have_grid = true;
	  horz_spacing = atoi((char*) fixed->GetProp("h_grid_spacing"));
	  vert_spacing = atoi((char*) fixed->GetProp("v_grid_spacing"));
	}
      if(have_grid)
	fixed_draw_grid (fixed->Container(), horz_spacing,
			 vert_spacing, 1); // dots
      
    }
  return true;
}

void
VDKBGuiForm::HandleOnKey(VDKObject* sender, GdkEventKey* event) 
{
  bool canResize = true;
  bool canMove = false;
  bool isKey = false;
  VDKBEventContainer* container = NULL;
  VDKBFixed* fixed = NULL;
  // we check if:
  // - there is an active widget
  // - active widget has a parent container
  // - key hits (only arrow keys allowed)
  // - parent container is a fixed (allows both resizing and moving)
  // otherwise only resizing is allowed
  //
  if(!Active)
    return;
  else
    {
      container = 
	dynamic_cast<VDKBEventContainer*>(Active->Object()->Parent());
      isKey = 
	(event->keyval == GDK_Up) || 
	(event->keyval == GDK_Right) ||
	(event->keyval == GDK_Down) ||
	(event->keyval == GDK_Left);
    }
  //
  if((!isKey) || (!container) )
    return;
  else if(!(fixed = dynamic_cast<VDKBFixed*>(container)))
    return;

  canMove = fixed != (VDKBFixed*) NULL;

#if VERBOSE
  printf("\nVDKBGuiForm::OnKey(): - active:%s - parent:%s",
	 (char*) Active->Name(),
	 fixed ? (char*) fixed->Name() : (char*) container->Name()
	 );
  printf("\nkey val:%d - state:%d",event->keyval,event->state);
  printf("\nSHIFT:%s - CTRL:%s",
	 event->state & GDK_SHIFT_MASK ? CHECK_YES : CHECK_NO,
	 event->state & GDK_CONTROL_MASK ? CHECK_YES : CHECK_NO);

  fflush(stdout);
#endif
  // check key modifiers
  bool isShift = event->state & GDK_SHIFT_MASK;
  bool isCtrl = event->state & GDK_CONTROL_MASK;
  bool isShiftCtrl = isShift && isCtrl;
  // unset isShift & isCtrl
  if(isShiftCtrl)
    isShift = isCtrl = false;

VDKPoint old_position(Active->Object()->Widget()->allocation.x,
		      Active->Object()->Widget()->allocation.y);
VDKPoint new_position = old_position;
VDKPoint old_size(Active->Object()->Widget()->allocation.width,
		  Active->Object()->Widget()->allocation.height);
VDKPoint new_size = old_size;
// grid job
 bool have_grid = false;
 int horz_spacing = 1,vert_spacing = 1;
 VDKString isTrue = CHECK_TRUE;
 if(fixed && fixed->GetProp("have_grid") == isTrue)
   {
     have_grid = true;
     horz_spacing = atoi((char*) fixed->GetProp("h_grid_spacing"));
     vert_spacing = atoi((char*) fixed->GetProp("v_grid_spacing"));
   }

switch(event->keyval)
  {
  case GDK_Left:
    if( have_grid && isShift)
	snap_left(new_position,horz_spacing);
    else if(isCtrl)
      new_size.x -= 1 ;
    else if(have_grid && isShiftCtrl)
      snap_left(new_size,horz_spacing);
    else
      new_position.x--;
    break;

  case GDK_Up:
    if(have_grid && isShift)
      snap_top(new_position,vert_spacing);
    else if(isCtrl)
      new_size.y -= 1 ;
    else if(have_grid && isShiftCtrl)
      snap_top(new_size,vert_spacing);
    else
      new_position.y -= 1;
    break;
  case GDK_Right:
    if(have_grid && isShift)
	snap_right(new_position,horz_spacing);
    else if(isCtrl)
      new_size.x += 1;
    else if(have_grid && isShiftCtrl)
      snap_right(new_size,horz_spacing);
    else
      new_position.x += 1;
    break;
  case GDK_Down:
    if(have_grid && isShift)
      snap_bottom(new_position,vert_spacing);
    else if(isCtrl)
      new_size.y += 1;
    else if(have_grid && isShiftCtrl)
      snap_bottom(new_size,vert_spacing);
    else
      new_position.y += 1;
    break;
  }
 if(canMove && (old_position != new_position))
   {
     gtk_fixed_move(GTK_FIXED(fixed->Container()),
		    Active->Object()->Widget(), 
		    new_position.x,
		    new_position.y);
     // corrects GTK+ bug. Some widgets do not move unless
     // you call gtk_widget_set_uposition()
     gtk_widget_set_uposition (Active->Object()->Widget(),  
			       new_position.x,  
			       new_position.y);  
     // update widget properties
     sprintf(buff,"%d",new_position.x);
     Active->SetPropValue(JUSTIFY_INTERNAL,buff);
     sprintf(buff,"%d",new_position.y);
     Active->SetPropValue(EXPAND_INTERNAL,buff);
     Changed = true;
   }
 else if (canResize &&(new_size != old_size))
   {
     Active->Object()->Usize = new_size;
     sprintf(buff,"%d,%d",new_size.x,new_size.y);
     Active->SetPropValue(USIZE,buff);
     Changed = true;
   }
 // redraw grid
 if(have_grid)
   ;//fixed_draw_grid (fixed->Container(), horz_spacing,
 //	    vert_spacing, 1); // dots
return ;
}


