/*
 * ===========================
 * VDK Builder
 * Version 0.1
 * Revision 0.0
 * January 1999
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library 
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#include <vdkb_prjpref.h>
#include <vdkb_locale.h>
#include <vdkb.h>
#define TABLE_ROWS 10
#define TABLE_COLS 2
static char buff[128];

DEFINE_SIGNAL_MAP(VDKBPrjPrefForm,VDKForm)
  ON_SIGNAL(ok,clicked_signal,Ok),
  ON_SIGNAL(cancel,clicked_signal,Cancel)
END_SIGNAL_MAP
//=======================================
/*
 */
bool
VDKBPrjPrefForm::Ok(VDKObject*)
{
  options->c_compiler = c_compiler->Text;
  options->cc_compiler = cc_compiler->Text;
  options->link = link->Text;
  options->c_flags = c_flags->Text;
  options->defines = defines->Text;
  options->includes = includes->Text;
  options->libs = libs->Text;
  options->debugger = debugger->Text;
  options->runargs = runargs->Text;
  options->version = version->Text;
  options->Save();
  VDKBMainForm* mainform = (VDKBMainForm*) Owner();
  // reload project options
  options->Load();
  // reset menu/options flag
  mainform->Automa(automa_prjman_on);
  Close();
  return true;
}
/*
 */
bool
VDKBPrjPrefForm::Cancel(VDKObject*)
{
Close();
return true;
}
//=======================================
/*
 */
VDKBPrjPrefForm::VDKBPrjPrefForm(VDKForm* owner, 
				 VDKBProjectOptions *options):
  VDKForm(owner),options(options)
{

}
/*
 */
VDKBPrjPrefForm:: ~VDKBPrjPrefForm()
{
}

/*
 */
void 
VDKBPrjPrefForm::Setup()
{
  
  int t;
  sprintf(buff,"%s - <%s>",
	  prjoptions_prompts[0],
	  (char*) options->filename);
  Title = buff;
  VDKBox* vbox = new VDKBox(this,v_box);
  table = new VDKTable(this,TABLE_ROWS,TABLE_COLS);
  for(t = 0; t < TABLE_ROWS ;t++)
    table->AddToCell(new VDKLabel(this,prjoptions_prompts[t+1]),t,0);
  c_compiler = new VDKEntry(this,0,options->c_compiler);
  c_compiler->SetSize(300,-1); 
  table->AddToCell(c_compiler,0,1); 
  cc_compiler = new VDKEntry(this,0,options->cc_compiler);
  table->AddToCell(cc_compiler,1,1); 
  link = new VDKEntry(this,0,options->link);
  table->AddToCell(link,2,1); 
  c_flags = new VDKEntry(this,0,options->c_flags);
  table->AddToCell(c_flags,3,1); 
  defines = new VDKEntry(this,0,options->defines);
  table->AddToCell(defines,4,1); 
  includes = new VDKEntry(this,0,options->includes);
  table->AddToCell(includes,5,1); 
  libs = new VDKEntry(this,0,options->libs);
  table->AddToCell(libs,6,1);
  debugger = new VDKEntry(this,0,options->debugger);
  table->AddToCell(debugger,7,1);
  runargs = new VDKEntry(this,0,options->runargs);
  table->AddToCell(runargs,8,1);
  version = new VDKEntry(this,0,options->version);
  table->AddToCell(version,9,1);
  vbox->Add(table);
  VDKFrame *frame = new VDKFrame(this,NULL,h_box);
  ok = new VDKLabelButton(this,prjoptions_prompts[TABLE_ROWS+1]);
  cancel = new VDKLabelButton(this,prjoptions_prompts[TABLE_ROWS+2]);
  frame->Add(ok);
  frame->Add(cancel);
  vbox->Add(frame,l_justify,false,false,false);
  Add(vbox);
}
