/*
 * ===========================
 * VDK Builder
 * Version 0.1
 * Revision 0.0
 * January 1999
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library 
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#include <vdkb_prjwiz.h>
#include <vdk/FileSaveAsDialog.h>
#include <vdkb_utils.h>
extern char *app_wiz_xpm[];
extern char *wizard_wiz_xpm[];
extern char *compo_wiz_xpm[];
extern char *exec_xpm[];
extern char* app_wiz_xpm[];
static char buff[256];
///////////////////////////////
DEFINE_SIGNAL_MAP(VDKBProjectWizard,VDKForm)
  ON_SIGNAL(prjname,changed_signal,OnEntryChange),
  ON_SIGNAL(toolbar,clicked_signal,HandleToolbar),
  ON_SIGNAL(browse,clicked_signal,OnBrowse),
  ON_SIGNAL(cancel,clicked_signal,OnCancel)
END_SIGNAL_MAP 
///////////////////////////////
bool
VDKBProjectWizard::OnCancel(VDKObject*)
{
prjname->Text = "";
*type = -1;
Close();
return true;
}
/*
 */
bool
VDKBProjectWizard::OnEntryChange(VDKObject*)
{
  bool flag = (!VDKString(prjname->Text).isNull()) &&
    (!strchr(prjname->Text,' '));
  (*toolbar)[0]->Enabled = flag;
  (*toolbar)[1]->Enabled = flag;
  /*
    fix it when all types will be available
    for(int t = 0; t < list->size(); t++)
    (*toolbar)[t]->Enabled = flag;
  */
  select_label->Enabled = flag; 
  return true;
}
////////////////////////////////////////////
bool
VDKBProjectWizard::OnBrowse(VDKObject*)
{
  FileStringArray selections;
  VDKFileSaveAsDialog *child = new VDKFileSaveAsDialog(this,&selections);
  child->Title = prjwiz_prompts[0];
  child->Filter = "*.prj";
  child->ShowModal(); 
  if(selections.size() <= 0)
      return false;
  else
    {
      strcpy(buff,selections[0]);
      char* p = get_extension(buff);
      if(! p)
	strcat(buff,".prj");
      else if(strcmp(p,"prj"))
	{
	  *p = '\0';
	  strcat(buff,".prj");
	}
      prjname->Text = buff;
    }
return true;
}
///////////////////////////////
bool
VDKBProjectWizard::HandleToolbar(VDKObject*)
{
*type = toolbar->ButtonPressed;
Close();
return true;
}
/////////////////////////////////////////////
/*
 */
bool
VDKBProjectWizard::CanClose()
{
*project = prjname->Text;
return true;
}
////////////////////////////////////////////////////////////////////////
VDKBProjectWizard::VDKBProjectWizard(VDKForm* owner,VDKString* project, int* type):
  VDKForm(owner,NULL),project(project),type(type)
{
}
/*
 */
VDKBProjectWizard::~VDKBProjectWizard()
{
}
/*
 */
void
VDKBProjectWizard::Setup()
{
  int t;
  Title = prjwiz_prompts[0];

  toolbar = new VDKToolbar(this);
  toolbar->Style = GTK_TOOLBAR_BOTH;
  toolbar->Spacing = 10;
  toolbar->AddButton(app_wiz_xpm,prjwiz_prompts[1],prjwiz_prompts[2]);
  toolbar->AddSpace();
  toolbar->AddButton(wizard_wiz_xpm,prjwiz_prompts[3],prjwiz_prompts[4]);
  toolbar->AddSpace();
  toolbar->AddButton(compo_wiz_xpm,prjwiz_prompts[5],prjwiz_prompts[6]);
  toolbar->AddSpace();
  toolbar->AddButton(exec_xpm,prjwiz_prompts[7],prjwiz_prompts[8]);
  GtkWidgetList* list = toolbar->ButtonList;
  for(t=0; t < list->size(); t++)
    (*toolbar)[t]->Enabled = false;
  Add(toolbar);
  Add(new VDKSeparator(this,h_separator));
  VDKFrame* frame = new VDKFrame(this,NULL,v_box);
   VDKBox* hbox = new VDKBox(this,h_box);
   hbox->Add(new VDKLabel(this,prjwiz_prompts[9]));
   prjname = new VDKEntry(this);
   prjname->SetSize(300,0);
   hbox->Add(prjname);
   frame->Add(hbox);
   VDKBox* hbox1 = new VDKBox(this,h_box);
   select_label = new VDKLabel(this,
   		       prjwiz_prompts[13]);
   select_label->Enabled = false;
   hbox1->Add(select_label);
   cancel = new VDKLabelButton(this,user_messages[3]);
   hbox1->Add(cancel);
   frame->Add(hbox1);
   Add(frame);
}

/*
 */
void
VDKBProjectWizard::OnShow(VDKForm*)
{
if(!OnBrowse(NULL))
   {
     prjname->Text = "";
     Close();
   }
}


