/*
 * ===========================
 * VDK Builder
 * Version 0.1
 * Revision 0.0
 * January 1999
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library 
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#ifndef _vdkb_prj_wiz_h
#define _vdkb_prj_wiz_h
#include <vdk/vdk.h>
#include <vdkb_locale.h>

class VDKBProjectWizard: public VDKForm
{
  VDKString   *project;  
  int* type;
  //
  VDKToolbar  *toolbar;
  VDKEntry    *prjname;
  VDKPixmapButton *browse;
  VDKLabelButton* cancel;
  VDKLabel* select_label;
 public:
  VDKBProjectWizard(VDKForm* owner,VDKString* project, int* type);
  ~VDKBProjectWizard();
  void Setup();
  bool CanClose();
  bool OnCancel(VDKObject*);
  // signals
  bool OnEntryChange(VDKObject*);
  bool HandleToolbar(VDKObject*);
  bool OnBrowse(VDKObject*);
  void OnShow(VDKForm*);
  DECLARE_SIGNAL_MAP(VDKBProjectWizard);
};

#endif
