/*
 * ===========================
 * VDK Builder
 * Version 0.1
 * Revision 0.0
 * November 1998
 * ===========================
 *
 * Copyright (C) 1998,1999 Mario Motta
 * Developed by Mario Motta <mmotta@guest.net>
 *
 * Based on VDK Library 
 * Copyright (C) 1998, Mario Motta
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 * 02111-1307, USA.
 *
 */
#ifndef _vdkb_types_h
#define _vdkb_types_h
#include <vdk/vdkobj.h>
#include <vdk/value_sem_list.h>
#include <vdk/vdkstring.h>

// project types
enum { vdk_project , console_project, shared_project, static_project };

// 
typedef struct FormEventHandlers
{ 
  char *items[2];
  char* method;
};

typedef struct VDKBDefaultColors
{ 
  char* colorname; 
  int red,green,blue;
};

typedef struct OpState
{
int state, action,action_target;
VDKObject *source,*target;
};

extern OpState OperationalState;

// states
enum { op_ready = 0, op_stand_by };
// actions
enum { act_nope = 0, act_add_widget };
// targets
enum { tgt_no_target = 0 };

/*
tools palette
*/
#define CONTAINERS_TOOL_BEGIN 0x2000 /* 8 k */

#define CONTAINERS_TOOL_VBOX      CONTAINERS_TOOL_BEGIN
#define CONTAINERS_TOOL_HBOX      CONTAINERS_TOOL_BEGIN+1
#define CONTAINERS_TOOL_FRAME     CONTAINERS_TOOL_BEGIN+2
#define CONTAINERS_TOOL_TABLE     CONTAINERS_TOOL_BEGIN+3
#define CONTAINERS_TOOL_VPANED    CONTAINERS_TOOL_BEGIN+4
#define CONTAINERS_TOOL_HPANED    CONTAINERS_TOOL_BEGIN+5
#define CONTAINERS_TOOL_NBOOK     CONTAINERS_TOOL_BEGIN+6
#define CONTAINERS_TOOL_HANDLE    CONTAINERS_TOOL_BEGIN+7
#define CONTAINERS_TOOL_TOOLBAR   CONTAINERS_TOOL_BEGIN+8
#define CONTAINERS_TOOL_SCROLLED  CONTAINERS_TOOL_BEGIN+9
#define CONTAINERS_TOOL_MENUBAR   CONTAINERS_TOOL_BEGIN+10
#define CONTAINERS_TOOL_VRADIOBG  CONTAINERS_TOOL_BEGIN+11
#define CONTAINERS_TOOL_PACKER    CONTAINERS_TOOL_BEGIN+12
#define CONTAINERS_TOOL_FIXED     CONTAINERS_TOOL_BEGIN+13

#define CONTAINERS_TOOL_END       CONTAINERS_TOOL_FIXED
#define IS_A_CONTAINER(x) \
(( (x) >= CONTAINERS_TOOL_BEGIN) && ( (x) <= CONTAINERS_TOOL_END))

#define BUTTON_TOOL_BEGIN 0x2400 /* 9 k */

#define BUTTON_TOOL_LABEL_BUTTON   BUTTON_TOOL_BEGIN
#define BUTTON_TOOL_PIXMAP_BUTTON  BUTTON_TOOL_BEGIN+1
#define BUTTON_TOOL_SPIN_BUTTON    BUTTON_TOOL_BEGIN+2
#define BUTTON_TOOL_CHECK_BUTTON   BUTTON_TOOL_BEGIN+3
#define BUTTON_TOOL_RADIO_BUTTON   BUTTON_TOOL_BEGIN+4
#define BUTTON_TOOL_CUSTOM_BUTTON  BUTTON_TOOL_BEGIN+5
#define BUTTON_TOOL_END            BUTTON_TOOL_CUSTOM_BUTTON

#define IS_A_BUTTON(x) \
(( (x) >= BUTTON_TOOL_BEGIN) && ( (x) <= BUTTON_TOOL_END))

#define TEXT_TOOL_BEGIN 0x2800 /* 10 k */

#define TEXT_TOOL_LABEL  TEXT_TOOL_BEGIN
#define TEXT_TOOL_ENTRY  TEXT_TOOL_BEGIN+1
#define TEXT_TOOL_TEXT   TEXT_TOOL_BEGIN+2

#define TEXT_TOOL_END    TEXT_TOOL_TEXT 

#define IS_A_TEXT(x) \
(( (x) >= TEXT_TOOL_BEGIN) && ( (x) <= TEXT_TOOL_END))

#define MISC_TOOL_BEGIN 0x2C00 /* 11 k */

#define MISC_TOOL_CANVAS       MISC_TOOL_BEGIN
#define MISC_TOOL_PIXMAP       MISC_TOOL_BEGIN+1
#define MISC_TOOL_PROGRESS     MISC_TOOL_BEGIN+2
#define MISC_TOOL_SLIDER       MISC_TOOL_BEGIN+3
#define MISC_TOOL_STATUSBAR    MISC_TOOL_BEGIN+4
#define MISC_TOOL_TIMER        MISC_TOOL_BEGIN+5
#define MISC_TOOL_CUSTOMLIST   MISC_TOOL_BEGIN+6
#define MISC_TOOL_COMBOBOX     MISC_TOOL_BEGIN+7
#define MISC_TOOL_CUSTOMTREE   MISC_TOOL_BEGIN+8
#define MISC_TOOL_HSEPARATOR   MISC_TOOL_BEGIN+9
#define MISC_TOOL_VSEPARATOR   MISC_TOOL_BEGIN+10
#define MISC_TOOL_GRID         MISC_TOOL_BEGIN+11
#define MISC_TOOL_PLACEHOLDER  MISC_TOOL_BEGIN+12
#define MISC_TOOL_MENU_ITEM    MISC_TOOL_BEGIN+13
#define MISC_TOOL_END          MISC_TOOL_MENUITEM

#define IS_A_MISC(x) \
(( (x) >= MISC_TOOL_BEGIN) && ( (x) <= MISC_TOOL_END))

/*
 main form toolbar buttons
*/
#define NEW_PROJECT_BUTTON   0
#define NEW_UNIT_BUTTON      1
#define NEW_FORM_BUTTON      2
#define OPEN_PRJ_BUTTON      3 
#define OPEN_FILE_BUTTON     4
#define SAVE_PRJ_BUTTON      5
#define SAVE_FILE_BUTTON     6
/*
 main form toolbar1 buttons
*/
#define ADD_TO_PROJECT       0
#define REMOVE_FROM__PROJECT 1
#define UNIT_LIST            2
#define TOGGLE_FORM_UNIT     3
#define FORM_LIST            4
#define RUN_PRJ_BUTTON       5
/*
 project manager toolbar buttons
*/
#define ADD_UNIT_BUTTON        1
#define REMOVE_UNIT_BUTTON     2
#define ACTIVATE_EDITOR_BUTTON 3
#define FORM_PROPS_BUTTON      4
/*
 locale
*/
#define ITALIAN 0
#define ENGLISH 1
#define FRENCH 2
#define SPANISH 3
#define GERMAN 4
#define VDKB_USAGE "\nVDK Builder usage: vkdb [arg] &\n\
arg:\n\
-it = italian\n\
-en = english\n\
-fr = french\n\
-sp = spanish\n\
-de = german\n\
(default english)\n"

/* 
misc
*/
#define CORRECT_PROJECT_FILE (char*) "#VDK Builder 0.1# project file#"
#define VDKB_RESOURCE_FILE (char*) "res/vdkbrc"
#define VDKB_HINT_FILE     (char*) "cpphints"
#define VDKB_LOGO          (char*) "res/logo.xpm"
#define VDKB_HELP_INDEX    (char*) "res/index.htm"
#define VDKBVERSION        (char*) "VDKBuilder 0.1.6"
#define APPNAME            (char*) "VDKBuilder"
#define VDKB_LOCKFILE       (char*) ".vdkblock"
#define CHECK_TRUE         (char*) "true"
#define CHECK_FALSE        (char*) "false"
#define CHECK_YES          (char*) "yes"
#define CHECK_NO           (char*) "no"
/*
vdkb  maker
*/
typedef VDKValueList<VDKString> VDKBStringList;
typedef VDKValueListIterator<VDKString> VDKBStringListIterator;
/*
 ide defaults
*/
#define DEFAULTS_FILE      (char*) "res/vdkbide.defaults"
#define FORM_EXT           (char*) "frm"
#endif

/* 
defines for parser
*/
#define PARSER_CLASS            "class:"

// common to all widgets
#define NORMALBACKGROUND        "NormalBackground"
#define PRELIGHTBACKGROUND      "PrelightBackground"
#define INSENSITIVEBACKGROUND   "InsensitiveBackground"
#define ACTIVEBACKGROUND        "ActiveBackground"
#define SELECTEDBACKGROUND      "SelectedBackground"
#define FOREGROUND              "Foreground"
#define FONT                    "Font"
#define ENABLED                 "Enabled"
#define CURSOR                  "Cursor"
#define USIZE                   "Usize"
#define VISIBLE                 "Visible"
#define JUSTIFY_INTERNAL         "_justify"
#define EXPAND_INTERNAL         "_Expand
// STUB HERE *******"
#define FILL_INTERNAL           "_Fill" 
#define PADDING_INTERNAL        "_Padding"
#define TIP                     "Tip"
#define TAG                     "Tag"
#define LABEL                   "Label"
#define TABLEROW                "TableRow"
#define TABLECOL                "TableCol"


/*
defines for properties
*/
// common to all widgets

#define PROP_NORMALBACKGROUND        "NormalBackground:"
#define PROP_PRELIGHTBACKGROUND      "PrelightBackground:"
#define PROP_INSENSITIVEBACKGROUND   "InsensitiveBackground:"
#define PROP_ACTIVEBACKGROUND        "ActiveBackground:"
#define PROP_SELECTEDBACKGROUND      "SelectedBackground:"
#define PROP_FOREGROUND              "Foreground:"
#define PROP_FONT                    "Font:"
#define PROP_ENABLED                 "Enabled:"
#define PROP_CURSOR                  "Cursor:"
#define PROP_USIZE                   "Usize:"
#define PROP_VISIBLE                 "Visible:"
#define PROP_JUSTIFY_INTERNAL        "_justify:"
#define PROP_EXPAND_INTERNAL         "_Expand:"
#define PROP_FILL_INTERNAL           "_Fill:"
#define PROP_PADDING_INTERNAL        "_Padding:"
#define PROP_TIP                     "Tip:"
#define PROP_TAG                     "Tag:"
#define PROP_LABEL                   "Label:"
#define PROP_TABLEROW                "TableRow:"
#define PROP_TABLECOL                "TableCol:"







